namespace Unibas.MorraCinese {

public class ControlloPartita {

    private Gioco gioco;

    public void SetGioco(Gioco gioco) {
         this.gioco = gioco;
    }

    public void GiocaNuovaPartita() {
        Partita partita = new Partita();
        bool continua = true;
        while (continua) {
            int scelta = SchermoMenuPartita(partita);
            if (scelta == 0) {
                SchermoPartitaInterrotta(partita);
                continua = false;
            } else {
                Mano mano = new Mano();
            	mano.Gioca((Oggetto)scelta);
            	partita.GestisciMano(mano);
                SchermoEsitoMano(mano);
                if (partita.Stato != StatoPartita.PARTITAINCORSO) {
                    SchermoEsitoPartita(partita);
                    continua = false;
                }
            }
        }
    }

    private int SchermoMenuPartita(Partita partita) {
        int scelta;
        System.Console.WriteLine("+-------------------------------------+");
        System.Console.WriteLine("   " + this.gioco.NomeGiocatore + ": punti " + partita.ManiVinteDalGiocatore);
        System.Console.WriteLine("   Computer: punti " + partita.ManiVinteDalComputer);
        System.Console.WriteLine("   Pareggi: " + partita.Pareggi);
        System.Console.WriteLine("+-------------------------------------+");
        System.Console.WriteLine("+-------------------------------------+");
        System.Console.WriteLine("   Inserisci la tua giocata");
        System.Console.WriteLine("+-------------------------------------+");
        System.Console.WriteLine("|  1. carta                           |");
        System.Console.WriteLine("|  2. forbici                         |");
        System.Console.WriteLine("|  3. sasso                           |");
        System.Console.WriteLine("|                                     |");
        System.Console.WriteLine("|  0. Interrompi partita              |");
        System.Console.WriteLine("+-------------------------------------+");
        System.Console.Write("   Scelta --> ");
        scelta = Unibas.Utilita.Console.LeggiIntero();
        while ((scelta < 0) || (scelta > 3)) {
            System.Console.WriteLine("*****  Errore: Scelta scorretta. Nuova scelta ? ");
            scelta = Unibas.Utilita.Console.LeggiIntero();
        }
        return scelta;
    }

    private void SchermoEsitoMano(Mano mano) {
        System.Console.WriteLine("+-------------------------------------+");
        System.Console.WriteLine("  " + this.gioco.NomeGiocatore + ", hai giocato: ");
        System.Console.WriteLine(GetSimbolo(mano.GiocataGiocatore));
        System.Console.WriteLine("   Il computer ha giocato: ");
        System.Console.WriteLine(GetSimbolo(mano.GiocataComputer));
        EsitoMano esito = mano.Esito;
        if (esito == EsitoMano.MANOVINTADALCOMPUTER) {
            System.Console.WriteLine("  Peccato, hai perso la mano");
        } else if (esito == EsitoMano.MANOVINTADALGIOCATORE) {
            System.Console.WriteLine("  Bravo, hai vinto la mano");
        } else if (esito == EsitoMano.MANOINPAREGGIO) {
            System.Console.WriteLine("  Si e' verificato un pareggio");
        }
        System.Console.WriteLine("+-------------------------------------+");
    }

    private void SchermoEsitoPartita(Partita partita) {
        System.Console.WriteLine("+-------------------------------------+");
        System.Console.WriteLine("   " + this.gioco.NomeGiocatore + " hai vinto " + partita.ManiVinteDalGiocatore + " mani");
        System.Console.WriteLine("   Il computer ha vinto " + partita.ManiVinteDalComputer + " mani");
        System.Console.WriteLine("   Ci sono stati " + partita.Pareggi + " pareggi");
        System.Console.WriteLine("+-------------------------------------+");
        if (partita.Stato == StatoPartita.PARTITAVINTADALGIOCATORE) {
            System.Console.WriteLine("  Bravo, " + gioco.NomeGiocatore + " hai vinto la partita");
        } else if (partita.Stato == StatoPartita.PARTITAVINTADALCOMPUTER){
            System.Console.WriteLine("  Peccato, " + gioco.NomeGiocatore + " hai perso la partita");
        }
        this.gioco.GestisciPartita(partita);
        System.Console.WriteLine("+-------------------------------------+");
    }

    private string GetSimbolo(Oggetto mossa) {
        System.Text.StringBuilder simbolo = new System.Text.StringBuilder();
        if (mossa == Oggetto.CARTA) {
            simbolo.Append(" _____  \n");
            simbolo.Append("| ___ \\ \n");
            simbolo.Append("| ___ | \n");
            simbolo.Append("| ___ | \n");
            simbolo.Append("|_____| \n");
        } else if (mossa == Oggetto.FORBICI) {
            simbolo.Append(" \\\\    // \n");
            simbolo.Append("  \\\\  //  \n");
            simbolo.Append("   \\\\//   \n");
            simbolo.Append("   //\\\\   \n");
            simbolo.Append("  //  \\\\  \n");
            simbolo.Append(" ()    ()   \n");
        } else if (mossa == Oggetto.SASSO) {
            simbolo.Append("  ___   \n");
            simbolo.Append(" (   )  \n");
            simbolo.Append("( (   ) \n");
            simbolo.Append("(____)  \n");
            simbolo.Append("\n");
        }
        return simbolo.ToString();
    }

    private void SchermoPartitaInterrotta(Partita partita) {
        System.Console.WriteLine("+-------------------------------------+");
        System.Console.WriteLine("   Partita interrotta. Fino a questo punto:");
        System.Console.WriteLine("   " + gioco.NomeGiocatore + " avevi vinto " + partita.ManiVinteDalGiocatore + " mani");
        System.Console.WriteLine("   Il computer aveva vinto " + partita.ManiVinteDalComputer + " mani");
        System.Console.WriteLine("   C'erano stati " + partita.Pareggi + " pareggi");
        System.Console.WriteLine("+-------------------------------------+");
    }

}

}
