namespace Unibas.MorraCinese {

public class ControlloPrincipale {
    
    private Gioco gioco;
    private ControlloPartita controlloPartita;
        
    public void Gioca() {
        this.gioco = new Gioco();
        controlloPartita = new ControlloPartita();
        string nomeGiocatore = SchermoIniziale();
        gioco.NomeGiocatore = nomeGiocatore;
        controlloPartita.SetGioco(this.gioco);
        bool continua = true;
        while (continua) {
            int scelta = SchermoMenuPrincipale();
            if (scelta == 0) {
                continua = false;
            } else if (scelta == 1) {
                controlloPartita.GiocaNuovaPartita();
            } else if (scelta == 2) {
                SchermoVittorie();
            }
        }
    }
    
    private string SchermoIniziale(){
        // attenzione: nomeGiocatore non puo' essere un parametro
        System.Console.WriteLine();
        System.Console.WriteLine("Benvenuto nella Morra Cinese");
        System.Console.WriteLine("--------------------------------------");
        System.Console.Write("Immetti il tuo nome per iniziare il gioco: ");
        string nomeGiocatore = Unibas.Utilita.Console.LeggiStringa();
        System.Console.WriteLine("+-------------------------------------+");
        System.Console.WriteLine("   Benvenuto, " + nomeGiocatore);
        System.Console.WriteLine("+-------------------------------------+");
        return nomeGiocatore;
    }
    
    
    private int SchermoMenuPrincipale() {
        int scelta;
        System.Console.WriteLine("+-------------------------------------+");
        System.Console.WriteLine("|  1. Nuova Partita                   |");
        System.Console.WriteLine("|  2. Visualizza Vittorie             |");
        System.Console.WriteLine("|  0. Esci dal Gioco                  |");
        System.Console.WriteLine("+-------------------------------------+");
        System.Console.Write("   Scelta --> ");
        scelta = Unibas.Utilita.Console.LeggiIntero();
        while ((scelta < 0) || (scelta > 2)) {
            System.Console.Write("*****  Errore: Scelta scorretta. Nuova scelta --> ");
            scelta = Unibas.Utilita.Console.LeggiIntero();
        }
        return scelta;
    }
    
    private void SchermoVittorie() {
        System.Console.WriteLine("+-------------------------------------+");
        System.Console.WriteLine("   " + gioco.NomeGiocatore + " hai vinto " + gioco.PartiteVinteDalGiocatore + " partite");
        System.Console.WriteLine("   Il computer ha vinto " + gioco.PartiteVinteDalComputer + " partite");
        System.Console.WriteLine("+-------------------------------------+");
        return;
    }
    
    public static void Main(string[] args){
        ControlloPrincipale controlloPrincipale = new ControlloPrincipale();
        controlloPrincipale.Gioca();
    }
    
}

}
