namespace Unibas.MorraCinese {

public enum Oggetto {CARTA = 1, FORBICI, SASSO};
public enum EsitoMano {MANOVINTADALCOMPUTER, MANOVINTADALGIOCATORE, MANOINPAREGGIO};

public class Mano {

    private System.Random generatore = new System.Random();
    
    private Oggetto giocataGiocatore;
    private Oggetto giocataComputer;

    public void Gioca(Oggetto giocataGiocatore) {
        System.Diagnostics.Debug.Assert(IsValida(giocataGiocatore), "Giocata non valida: " + giocataGiocatore);
        this.GiocataGiocatore = giocataGiocatore;
        GeneraGiocataComputer();
    }

    public bool IsValida(Oggetto giocata) {
        return (giocata == Oggetto.CARTA || giocata == Oggetto.FORBICI || giocata == Oggetto.SASSO);
    }

    public Oggetto GiocataGiocatore {
        get { return this.giocataGiocatore; }
        set { this.giocataGiocatore = value; }
    }

    public Oggetto GiocataComputer {
        get { return this.giocataComputer; }
    }

    private void GeneraGiocataComputer() {
        this.giocataComputer = (Oggetto)System.Math.Abs(generatore.Next(3) + 1);
    }

    public EsitoMano Esito {
        get {
            EsitoMano esito = EsitoMano.MANOVINTADALCOMPUTER;
            if (this.giocataGiocatore == this.giocataComputer) {
                esito = EsitoMano.MANOINPAREGGIO;
            } else if ((this.giocataGiocatore == Oggetto.CARTA) && (this.giocataComputer == Oggetto.SASSO)) {
                esito = EsitoMano.MANOVINTADALGIOCATORE;
            } else if ((this.giocataGiocatore == Oggetto.FORBICI) && (this.giocataComputer == Oggetto.CARTA)) {
                esito = EsitoMano.MANOVINTADALGIOCATORE;
            } else if ((this.giocataGiocatore == Oggetto.SASSO) && (this.giocataComputer == Oggetto.FORBICI)) {
                esito = EsitoMano.MANOVINTADALGIOCATORE;
            }
            return esito;
        }
    }
}

}
