namespace Unibas.MorraCinese {

public enum StatoPartita {PARTITAVINTADALCOMPUTER, PARTITAVINTADALGIOCATORE, PARTITAINCORSO};

public class Partita {
    
    public const int LIMITEMANI = 3;
        
    private int maniVinteDalComputer = 0;
    private int maniVinteDalGiocatore = 0;
    private int pareggi = 0;
    
    public int ManiVinteDalComputer {
        get { return this.maniVinteDalComputer; }
    }
    
    public int ManiVinteDalGiocatore {
        get { return this.maniVinteDalGiocatore; }
    }
    
    public int Pareggi {
        get { return this.pareggi; }
    }
    
    public void GestisciMano(Mano mano) {
        System.Diagnostics.Debug.Assert(this.Stato == StatoPartita.PARTITAINCORSO, "Partita conclusa. Stato: " + this.Stato);
        EsitoMano esito = mano.Esito;
        if (esito == EsitoMano.MANOVINTADALCOMPUTER) {
            this.maniVinteDalComputer++;
        } else if (esito == EsitoMano.MANOVINTADALGIOCATORE) {
            this.maniVinteDalGiocatore++;
        } else if (esito == EsitoMano.MANOINPAREGGIO) {
            this.pareggi++;
        }
    }
    
    public StatoPartita Stato {
        get {
            StatoPartita stato = StatoPartita.PARTITAINCORSO;
            if (this.maniVinteDalComputer == Partita.LIMITEMANI) {
                stato = StatoPartita.PARTITAVINTADALCOMPUTER;
            } else if (this.maniVinteDalGiocatore == Partita.LIMITEMANI) {
                stato = StatoPartita.PARTITAVINTADALGIOCATORE;
            }
            return stato;
        }
    }
    
}

}
