namespace Unibas.MorraCinese.Test {

using NUnit.Framework;
using Unibas.MorraCinese;

[TestFixture]
public class TestMano {
    
    private Mano mano;
     
    [SetUp]
    public void SetUp() {
        mano = new Mano();
    }
    
    [Test]
    public void TestIsValida() {
        Assert.IsTrue(mano.IsValida(Oggetto.CARTA), "carta");
        Assert.IsTrue(mano.IsValida(Oggetto.FORBICI), "forbici");
        Assert.IsTrue(mano.IsValida(Oggetto.SASSO), "sasso");
        Assert.IsTrue(!mano.IsValida((Oggetto)10), "non valido 10");
    }
    
    [Test]
    public void TestGioca1() {
        mano.Gioca(Oggetto.CARTA);
        if (mano.GiocataComputer == Oggetto.CARTA) {
            Assert.IsTrue(mano.Esito == EsitoMano.MANOINPAREGGIO, "pareggio");
        } else if (mano.GiocataComputer == Oggetto.SASSO) {
            Assert.IsTrue(mano.Esito == EsitoMano.MANOVINTADALGIOCATORE, "vince il giocatore");            
        } else if (mano.GiocataComputer == Oggetto.FORBICI) {
            Assert.IsTrue(mano.Esito == EsitoMano.MANOVINTADALCOMPUTER, "vince il computer");
        }
    }
    
    [Test]
    public void TestGioca2() {
        mano.Gioca(Oggetto.FORBICI);
        if (mano.GiocataComputer == Oggetto.FORBICI) {
            Assert.IsTrue(mano.Esito == EsitoMano.MANOINPAREGGIO, "pareggio");
        } else if (mano.GiocataComputer == Oggetto.CARTA) {
            Assert.IsTrue(mano.Esito == EsitoMano.MANOVINTADALGIOCATORE, "vince il giocatore");            
        } else if (mano.GiocataComputer == Oggetto.SASSO) {
            Assert.IsTrue(mano.Esito == EsitoMano.MANOVINTADALCOMPUTER, "vince il computer");
        }
    }

    [Test]
    public void TestGioca3() {
        mano.Gioca(Oggetto.SASSO);
        if (mano.GiocataComputer == Oggetto.SASSO) {
            Assert.IsTrue(mano.Esito == EsitoMano.MANOINPAREGGIO, "pareggio");
        } else if (mano.GiocataComputer == Oggetto.FORBICI) {
            Assert.IsTrue(mano.Esito == EsitoMano.MANOVINTADALGIOCATORE, "vince il giocatore");            
        } else if (mano.GiocataComputer == Oggetto.CARTA) {
            Assert.IsTrue(mano.Esito == EsitoMano.MANOVINTADALCOMPUTER, "vince il computer");
        }
    }
    
    [Test]
    public void TestGiocateComputer() {
        int[] oggetti = {0, 0, 0, 0};
        for (int i = 0; i < 20; i++) {
            mano.Gioca(Oggetto.CARTA);
            oggetti[(int)mano.GiocataComputer]++;
        }
        Assert.IsTrue(oggetti[1] != 0, "tutti gli oggetti");
        Assert.IsTrue(oggetti[2] != 0, "tutti gli oggetti");
        Assert.IsTrue(oggetti[3] != 0, "tutti gli oggetti");        
    }

}


}
